| package |
package := Package name: 'TwitterAPI'.
package paxVersion: 1;
	basicComment: ''.


package classNames
	add: #Twitter;
	yourself.

package binaryGlobalNames: (Set new
	yourself).

package globalAliases: (Set new
	yourself).

package setPrerequisites: (IdentitySet new
	add: '..\Object Arts\Dolphin\Base\Dolphin';
	add: 'HTTP-Encoding';
	add: 'JSON';
	add: '..\Object Arts\Dolphin\ActiveX\Components\XML DOM\XML DOM';
	yourself).

package!

"Class Definitions"!

Object subclass: #Twitter
	instanceVariableNames: 'username password'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!

"Global Aliases"!


"Loose Methods"!

"End of package definition"!

"Source Globals"!

"Classes"!

Twitter guid: (GUID fromString: '{6D9FA539-1B9C-4BD2-B90E-AAB355F4D1E8}')!
Twitter comment: ''!
!Twitter categoriesForClass!Kernel-Objects! !
!Twitter methodsFor!

encodeDictionary: aDictionary
	" encode values "
	| stream policy |
	policy := UrlEncodingPolicy new.
	stream := WriteStream on: String new.
	aDictionary associationsDo: [ :ea | 
		stream nextPutAll: (policy encode: ea key). 
		stream nextPutAll: '='.
		stream nextPutAll: (policy encode: ea value) ] separatedBy: [ stream nextPutAll: '&' ].
	^stream contents!

executeGetRequestOn: aUrl
	^(self newRequestOn: aUrl method: 'GET')
		send;
		responseText!

executePostRequestOn: aUrl
	^(self newRequestOn: aUrl method: 'POST')
		send;
		responseText!

executePostRequestOn: aUrl with: aBody
	^(self newRequestOn: aUrl method: 'POST')
		SetRequestHeader: 'Content-Type' bstrValue: 'application/x-www-form-urlencoded';
		send: aBody;
		responseText!

followers
	| response |
	response := self executeGetRequestOn: self followersUrl.
	^self json: response!

followersUrl
	^'http://twitter.com/statuses/followers.json'!

json: aString
	^JsonReader readFrom: aString readStream!

newRequestOn: aUrl method: aMethod
	^IServerXMLHTTPRequest newServerXMLHTTP
		open: aMethod bstrUrl: aUrl varAsync: false bstrUser: username bstrPassword: password;
		yourself
	!

setUsername: usernameString password: passwordString
	username := usernameString.
	password := passwordString.
	^self!

status: aString
	| message response |
	message := Dictionary new.
	message at: 'status' put: aString.
	response := self executePostRequestOn: self updateUrl with: (self encodeDictionary: message).
	^self json: response!

updateUrl
	^'http://twitter.com/statuses/update.json'!

userTimeline: aUserId
	"http://twitter.com/statuses/user_timeline.json?id="
	| response |
	response := self executeGetRequestOn: self userTimelineUrl , '?id=' , aUserId.
	^self json: response!

userTimelineUrl
	^'http://twitter.com/statuses/user_timeline.json'! !
!Twitter categoriesFor: #encodeDictionary:!private! !
!Twitter categoriesFor: #executeGetRequestOn:!private! !
!Twitter categoriesFor: #executePostRequestOn:!private! !
!Twitter categoriesFor: #executePostRequestOn:with:!private! !
!Twitter categoriesFor: #followers!accessing!public! !
!Twitter categoriesFor: #followersUrl!public!urls! !
!Twitter categoriesFor: #json:!private! !
!Twitter categoriesFor: #newRequestOn:method:!private! !
!Twitter categoriesFor: #setUsername:password:!private! !
!Twitter categoriesFor: #status:!operations!public! !
!Twitter categoriesFor: #updateUrl!public!urls! !
!Twitter categoriesFor: #userTimeline:!accessing!public! !
!Twitter categoriesFor: #userTimelineUrl!public!urls! !

!Twitter class methodsFor!

username: usernameString password: passwordString
	^self new setUsername: usernameString password: passwordString! !
!Twitter class categoriesFor: #username:password:!instance creation!public! !

"Binary Globals"!

